# JUnitTileLimit Mod
# By: Jeckel
# 
# 

from CvPythonExtensions import *
import Popup as PyPopup
import CvAlertManager
alert = CvAlertManager.CvAlertManager()
import CvJUnitTileLimitUtils
modUtils = CvJUnitTileLimitUtils.CvJUnitTileLimitUtils()

gc = CyGlobalContext()

class CvJUnitTileLimitEventManager:
	
	def __init__(self, eventManager):
		self.EventKeyDown=6
		self.eventManager = eventManager

		eventManager.addEventHandler("kbdEvent", self.onKbdEvent)
		#eventManager.addEventHandler("windowActivation", self.onWindowActivation)
 		#eventManager.addEventHandler("mouseEvent", self.onMouseEvent)
	
	def onMouseEvent(self, argsList):
		eventType,mx,my,px,py,interfaceConsumed,screens = argsList

                #gc.getPlayer(18).killUnits()

		objPlot = gc.getMap().plot(px,py)

	def onWindowActivation(self, argsList):
		'Called when the game window activates or deactivates'
		bActive = argsList[0]
		
		if (bActive):
                        pass

	################################################################################################
		
	# This method handles the key input and will bring up the
	# Tile Unit Limit Data Popup if the player presses the 'CTRL-ALT-L' key.
	def onKbdEvent(self, argsList):
		'keypress handler - return 1 if the event was consumed'
		eventType,key,mx,my,px,py = argsList
			
		theKey=int(key)

		if (eventType == self.EventKeyDown):
                        iPlayer = gc.getGame().getActivePlayer()
                        pPlayer = gc.getPlayer(iPlayer)
                        pPlot = CyMap().plot(px, py)
                        #  - F1
                        if (theKey == int(InputTypes.KB_F1)) \
                           and (not self.eventManager.bAlt) \
                           and (not self.eventManager.bCtrl) \
                           and (not self.eventManager.bShift) \
                           and (False):
                                sText = "A Test"
                                sText += u"\nFontSymbols.MAP_CHAR: %c" %CyGame().getSymbolID(FontSymbols.MAP_CHAR)
                                #sText += u"\nFontSymbols.TILE_SPACE_CHAR: %c" %CyGame().getSymbolID(FontSymbols.TILE_SPACE_CHAR)
                                #for i in range(24):
                                        #sText += "\n"
                                        #sText += u"%c" %CyGame().getSymbolID(i)
                                sText += "\n\n"
                                alert.popup(0, sText)
                                return 1
                        # Tile Unit Limit Data Popup - SHIFT + K
                        if (theKey == int(InputTypes.KB_K)) \
                           and (not self.eventManager.bAlt) \
                           and (not self.eventManager.bCtrl) \
                           and (self.eventManager.bShift) \
                           and (False):
                                if (pPlot == None) or (pPlot == -1) or (pPlot.isNone()):
                                        return 0
                                popup = PyPopup.PyPopup(EventContextTypes.EVENTCONTEXT_ALL)
                                popup.setUserData((-1, -1))
                                popup.setHeaderString("TILE SPACE DATA")
                                #popup.setBodyString("Please name the fort:")
                                popup.createTable(4, 3, 0)
                                popup.setTableCellSize(1, 100, 0)
                                popup.setTableYSize(0, 50, 0)
                                popup.addTableCellText(0, 0, "Terrain", 0)
                                popup.addTableCellText(1, 0, "Feature", 0)
                                popup.addTableCellText(2, 0, "Resource", 0)
                                popup.addTableCellText(3, 0, "Improvement", 0)
                                popup.completeTableAndAttach(0)
                                popup.launch()
                                return 1
                        # Tile Unit Limit Data Popup - SHIFT + L
                        if (theKey == int(InputTypes.KB_L)) \
                           and (not self.eventManager.bAlt) \
                           and (not self.eventManager.bCtrl) \
                           and (self.eventManager.bShift):
                                if (pPlot == None) or (pPlot == -1) or (pPlot.isNone()):
                                        return 0
                                sText = u"<font=4b>TILE SPACE DATA</font>"
                                sText += "\n\n"
                                if (pPlot.isWater()):
                                        sDomainKind = "Water"
                                else:
                                        sDomainKind = "Land"
                                sText += "<font=3b>Default Space:</font> %s <font=3b>(</font>" %sDomainKind
                                sText += "%d<font=3b>)</font>" %modUtils.getBaseLimit(pPlot)
                                #sText += "\n\n"
                                #sText += "<font=3b>X:</font> %d, <font=3b>Y:</font> %d" %(px, py)
                                sText += "\n"
                                if (pPlot.isCity()):
                                        pCity = pPlot.getPlotCity()
                                        sCityName = pCity.getName()
                                        #sText += "\n"
                                        sText += "<font=3b>City:</font> %s" %sCityName
                                        if (modUtils.getEnableOption("Enable City Limit Modifiers", True)):
                                                sText += " <font=3b>(</font>"
                                                iModCity = modUtils.getModsCity(pCity)
                                                if (iModCity > 0):
                                                        sText += "+"
                                                sText += "%d<font=3b>)</font>" %iModCity
                                        if (modUtils.getEnableOption("Enable City Building Limit Modifiers", True)):
                                                sText += "\n"
                                                iCountBuildings = 0
                                                for i in range(gc.getNumBuildingInfos()):
                                                        if (pCity.getNumRealBuilding(i) > 0):
                                                                if (modUtils.getBuildingMod(gc.getBuildingInfo(i).getType()) > 0):
                                                                        iCountBuildings += 1
                                                sText += "<font=3b>Buildings/Total:</font> %d<font=3b>/</font>%d <font=3b>(</font>" %(iCountBuildings, pCity.getNumBuildings())
                                                iModCityBuilding = modUtils.getModsCityBuilding(pCity)
                                                if (iModCityBuilding > 0):
                                                        sText += "+"
                                                sText += "%d<font=3b>)</font>" %iModCityBuilding
                                        if (modUtils.getEnableOption("Enable City Culture Level Limit Modifiers", True)):
                                                sText += "\n"
                                                sText += "<font=3b>Culture Level:</font> %s <font=3b>(</font>" %gc.getCultureLevelInfo(pCity.getCultureLevel()).getDescription()
                                                iModCityCultureLevel = modUtils.getModsCityCultureLevel(pCity)
                                                if (iModCityCultureLevel > 0):
                                                        sText += "+"
                                                sText += "%d<font=3b>)</font>" %iModCityCultureLevel
                                        sText += "\n\n"
                                #sText += "\n\n"
                                bSpace = False
                                if (modUtils.getEnableOption("Enable Terrain Limit Modifiers", True)):
                                        bSpace = True
                                        sText += "<font=3b>Terrain:</font> "
                                        if (pPlot.isHills()):
                                                sText += "Hills<font=3b>/</font>"
                                        sText += "%s <font=3b>(</font>" %gc.getTerrainInfo(pPlot.getTerrainType()).getDescription()
                                        if (pPlot.isHills()):
                                                sText += "%d<font=3b>/</font>" %modUtils.getTerrainMod("TERRAIN_HILL")
                                        iTerrain = pPlot.getTerrainType()
                                        iModTerrain = modUtils.getTerrainMod(gc.getTerrainInfo(iTerrain).getType())
                                        if (iModTerrain > 0):
                                                sText += "+"
                                        sText += "%d<font=3b>)</font>" %iModTerrain
                                if (modUtils.getEnableOption("Enable Feature Limit Modifiers", True)):
                                        bSpace = True
                                        iFeature = pPlot.getFeatureType()
                                        if (iFeature > -1):
                                                sText += "\n"
                                                sText += "<font=3b>Feature:</font> %s <font=3b>(</font>" %gc.getFeatureInfo(iFeature).getDescription()
                                                iModFeature = modUtils.getFeatureMod(gc.getFeatureInfo(iFeature).getType())
                                                if (iModFeature > 0):
                                                        sText += "+"
                                                sText += "%d<font=3b>)</font>" %iModFeature
                                if (modUtils.getEnableOption("Enable Bonus Limit Modifiers", True)):
                                        bSpace = True
                                        iBonus = pPlot.getBonusType(pPlayer.getID())
                                        if (iBonus > -1):
                                                sText += "\n"
                                                sText += "<font=3b>Resource:</font> %s <font=3b>(</font>" %gc.getBonusInfo(iBonus).getDescription()
                                                iModBonus = modUtils.getBonusMod(gc.getBonusInfo(iBonus).getType())
                                                if (iModBonus > 0):
                                                        sText += "+"
                                                sText += "%d<font=3b>)</font>" %iModBonus
                                if (modUtils.getEnableOption("Enable Improvement Limit Modifiers", True)):
                                        bSpace = True
                                        iImprovement = pPlot.getImprovementType()
                                        if (iImprovement > -1):
                                                sText += "\n"
                                                sText += "<font=3b>Improvement:</font> %s <font=3b>(</font>" %gc.getImprovementInfo(iImprovement).getDescription()
                                                iModImprovement = modUtils.getImprovementMod(gc.getImprovementInfo(iImprovement).getType())
                                                if (iModImprovement > 0):
                                                        sText += "+"
                                                sText += "%d<font=3b>)</font>" %iModImprovement
                                if (bSpace):
                                        sText += "\n\n"
                                iSpaceTotal = modUtils.getMaxUnits(pPlot, pPlayer)
                                sText += "<font=3b>Total Space:</font> %d" %iSpaceTotal
                                sText += "\n"
                                iSpaceUsed = modUtils.getPlotSizeCount(pPlot)
                                sText += "<font=3b>Units/Space:</font> %d<font=3b>/</font>%d" %(pPlot.getNumUnits(), iSpaceUsed)
                                sText += "\n"
                                iSpaceFree = iSpaceTotal - iSpaceUsed
                                sText += "<font=3b>Free Space:</font> %d" %iSpaceFree
                                alert.popup(iPlayer, sText)
                                return 1
                return 0

	################################################################################################
		
		
		
